#ifndef	_LINUX_AF_CAPTURE_H
#define _LINUX_AF_CAPTURE_H
#include <linux/tcp.h>

#define CAP_MAX_BUFFERSIZE	65535
#define AF_CAPTURE		25	
#define PF_CAPTURE		AF_CAPTURE

#define CAP_COPY_ALL	1
#define CAP_COPY_FLOW	2
#define CAP_TCP		3
#define MAX_CAPTYPE	16

#define CAP_ALIGNMENT 		sizeof(int)
#define CAP_WORDALIGN(x) 	(((x)+(CAP_ALIGNMENT-1))&~(CAP_ALIGNMENT-1))

/*
struct tcp_block
{
	__u16	block_size;
	__u16	data_size;
	__u32	saddr,daddr;
	__u32	time;
	struct	tcphdr th;
	char	data[0];
};

struct tcp_filter
{
	__u16 port;
};

struct all_type
{
	__u16			size;
	unsigned char		packet[0];
};

*/

#ifdef __KERNEL__
#include "cap_pack.h"

#ifdef MODVERSIONS
#ifdef __SMP__
#define __ver_cap_copy_type_register		smp_0ace8994
#define __ver_cap_copy_type_unregister		smp_0ace8995
#else 
#define __ver_cap_copy_type_register		0ace8994
#define __ver_cap_copy_type_unregister		0ace8995
#endif
#define cap_copy_type_register		_set_ver(cap_copy_type_register)
#define cap_copy_type_unregister	_set_ver(cap_copy_type_unregister)
#endif

#define CAP_PRIO_COPY_FLOW		0x1000

struct packet_opt;

struct cap_copy_type
{
	unsigned short 		type;
	int			min_copy_size;
	int			(*copy)(char *,struct sk_buff*,void *);
	int			(*open)(struct packet_opt *);
	void			(*close)(void*);
	int			(*ioctl)(unsigned int , unsigned long,void* );
};

struct capture_struct
{
	void 		       *store_slot;
	void		       *hold_slot;
	void		       *free_slot;
	unsigned long		store_len;
	unsigned long		hold_len;
	unsigned long		buffer_size;
	unsigned long		save_store_size;
	int                     read_timeout;
	atomic_t           	received;
	atomic_t           	dropped;
	spinlock_t		lock;
	struct timer_list       read_timer;
	struct cap_copy_type    *type;
	void                    *type_private;
};

struct packet_opt
{
	int                     	ifindex;
	int                     	running;
	struct cap_packet_type    	prot_hook;
	struct capture_struct          	cap;
};

extern int cap_copy_type_register(struct cap_copy_type *cp);
extern int cap_copy_type_unregister(unsigned short type);

#endif
#endif
