#ifndef FLOW_FUN_H
#define FLOW_FUN_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
#include <stdarg.h>
#include <pthread.h>
#include <time.h>
#include <sys/types.h>
#include <linux/types.h>
#include <linux/if_ether.h>
#include <asm/atomic.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <syslog.h>

#include "ipasct.h"
#include "flow_pub.h"
#include "list.h"
#include "hash.h"

#include "unp/unpthread.h"

struct hash_key {
	UADDR	saddr,daddr;
	UPORT	sport,dport;
	UPROTO	protocol;
};

struct session_type {
	struct hash_key key;
	USIZE flow[2];
	UTIME time[2];
};

struct session_queue {
	struct list_head list;
	struct session_type session;
};

int cap_sock;
int send_sock;
struct sockaddr_in send_addr;
FILE *log_fp;
pthread_mutex_t cap_sock_mutex;
pthread_mutex_t send_sock_mutex;
pthread_mutex_t log_fp_mutex;
int max_free_item;

/* read.c */
void *read_data_thread(void *dummy);
char *getdata(int *len);
void putdata();

/* process.c */
void *process_data_thread(void *dummy);
void put_item (struct session_queue *item);
void put_list (struct list_head *send_list,unsigned long list_len);
/* send.c */
void *send_data_thread(void *dummy);
int send_hash(HashTable *hash,struct list_head *list);

/* linuxflow.c */
#define write_log (*write_log_ptr)
extern void (*write_log_ptr)(char *fmt, ...);

#endif

