/*
 * 
 *Define the constants and data structure of IPAS
 *
 *first written by Zhang Hui Aug.24 2001
 *
 *motified by Li Zhi Chun Sep.04.2001
 *
 */

#ifndef _LINUX_IPASCT_H
#define _LINUX_IPASCT_H

#include <linux/types.h>

#define UINT  unsigned int
#define UADDR unsigned int  /*166.111.1.1=>0xA66F0101*/
#define NADDR unsigned int  /*network IP address :network byte order*/
#define HADDR unsigned int  /*network IP address :host byte order*/
#define UPORT	unsigned short int /*0-65535*/
#define UPROTO	unsigned short int /*defined in netinet/in.h according networking convention*/
#define USIZE	unsigned long/*0-4G*/
#define UTIME	time_t

#define SEND_PORT 3999
#define SEND_PADDR "127.0.0.1"

/*
 * sk_buff output of lpf
 */

struct flow_type
{
	__u32	saddr,daddr;
	__u16	sport,dport,protocol,length;
	__u32	time;
};

/*
 * output of lpf analysis program
 */

struct flow_record
{
	UADDR	saddr,daddr;
	UPORT	sport,dport;
	UPROTO	protocol;
	USIZE	len_sd;
	USIZE	len_ds;
	UTIME	t_sd;
	UTIME	t_ds;
};

#endif
