#include "flow_fun.h"
#include "flow_pub.h"
#include "ipasct.h"

static long long process_buf;
static long long read_buf;
static pthread_mutex_t read_buf_mutex=PTHREAD_MUTEX_INITIALIZER;
static pthread_mutex_t process_buf_mutex=PTHREAD_MUTEX_INITIALIZER;
static pthread_cond_t read_cond=PTHREAD_COND_INITIALIZER;
static pthread_cond_t process_cond=PTHREAD_COND_INITIALIZER;
static char*  readdata[READ_BUF_NUM];
static int readdata_size[READ_BUF_NUM];

static void allocbuf() 
{
	int i;
	process_buf=0;
	read_buf=0;
	for (i=0;i<READ_BUF_NUM;i++) {
		readdata_size[i]=0;
		readdata[i]=(char *)malloc (READ_BUF_SIZE*sizeof(char));
		if(readdata[i]==NULL) {
			write_log("read thread : Fatal Error: alloc read buffer: %s",strerror(errno));
			exit(EXIT_ERROR);
		}
	}
}

void *read_data_thread(void *dummy) 
{
	write_log("linuxflow read thread tid = %d   pid = %d",pthread_self(),getpid());
	Pthread_mutex_lock(&process_buf_mutex);
	allocbuf();
	Pthread_mutex_unlock(&process_buf_mutex);
	while (1) {
		Pthread_mutex_lock(&process_buf_mutex);
		while (read_buf-process_buf>=READ_BUF_NUM) {
			write_log("read thread : Losing readbuf data");
			Pthread_cond_wait(&read_cond,&process_buf_mutex);
		}
		Pthread_mutex_unlock(&process_buf_mutex);
		readdata_size[read_buf%READ_BUF_NUM]=read(cap_sock,readdata[read_buf%READ_BUF_NUM],READ_BUF_SIZE);
		Pthread_mutex_lock(&read_buf_mutex);
		read_buf++;
		Pthread_cond_signal(&process_cond);
		Pthread_mutex_unlock(&read_buf_mutex);
	}
}

__inline__ char *getdata(int *len) 
{
	Pthread_mutex_lock(&read_buf_mutex);
	while(process_buf>=read_buf) {
		Pthread_cond_wait(&process_cond,&read_buf_mutex);
	}
	Pthread_mutex_unlock(&read_buf_mutex);
	*len=readdata_size[process_buf%READ_BUF_NUM];
	return readdata[process_buf%READ_BUF_NUM];
}
__inline__ void putdata() 
{
	Pthread_mutex_lock(&process_buf_mutex);
	process_buf++;
	Pthread_cond_signal(&read_cond);
	Pthread_mutex_unlock(&process_buf_mutex);
}
