#ifndef CAP_PACK_H
#define CAP_PACK_H
#ifdef __KERNEL__
#include <linux/netdevice.h>

#ifdef MODVERSIONS
#ifdef __SMP__
#define __ver_cap_add_pack	smp_0ace8991
#define __ver_cap_remove_pack	smp_0ace8991
#else
#define __ver_cap_add_pack	0ace8991
#define __ver_cap_remove_pack	0ace8991
#endif
#define cap_add_pack		_set_ver(cap_add_pack)
#define cap_remove_pack		_set_ver(cap_remove_pack)
#endif

#define CAP_RX_CON		0x00010000
#define CAP_RX_FIN		0x00020000

struct cap_packet_type {
	unsigned short 		type;
	struct 			net_device *dev;
	int			(*func)(struct sk_buff *, struct net_device *, 
						struct cap_packet_type *);
	void			*data;
	struct cap_packet_type 	*next;
	int			prio;
};

extern void cap_add_pack(struct cap_packet_type *);
extern void cap_remove_pack(struct cap_packet_type *);
extern int  netif_rx(struct sk_buff *skb);

#endif 
#endif
