#ifndef CAP_PUB_H
#define CAP_PUB_H

/* When compiled into kernel, these two macro determine which softirq to use
 * to server Read and Transfer request .
 * You may change its values to avoid collision with other parts of kernel,
 * Num 1,2,3,4 are used in kernel 2.4
 */

#define CAP_RX_SOFTIRQ          6
#define CAP_TX_SOFTIRQ          7

/* Read timeout in unit of ms, tune it according your net data transfer rate */
#define DEF_TIMEOUT		1000

/*
 * CAP_COPY_HDR copy all IP and TCP(UDP) header to user space
 */
#define HDRLEN			40 /* length of IP+TCP header*/

/* CAP_COPY_VAR_IP  copy variable fields of iphdr and tcphdr or udphdr to
 * user space. Each macro control wether a field should be copied. The
 * macros are maded up by COPY_VAR_IP_ plus field name. Undefine macros to
 * exclude the fields.
 */

#define COPY_VAR_IP_VERSION	1
#define COPY_VAR_IP_TOS		1
#define COPY_VAR_IP_TOTAL_LEN	1
#define	COPY_VAR_IP_ID		1
#define COPY_VAR_IP_FRAGOFF	1
#define	COPY_VAR_IP_TTL		1
#define COPY_VAR_IP_PROTOCOL	1
#define COPY_VAR_IP_CHECK	1
#define COPY_VAR_IP_SADDR	1
#define COPY_VAR_IP_DADDR	1

#define COPY_VAR_TCP_SPORT	1
#define COPY_VAR_TCP_DPORT	1
#define COPY_VAR_UDP_SPORT	1
#define COPY_VAR_UDP_DPORT	1

#endif
