#ifdef MODVERSIONS
#include <linux/modversions.h>
#endif
#include <linux/config.h>
#include <linux/types.h>
#include <linux/init.h>
#include <linux/mm.h>
#include <linux/module.h>
#include <linux/netdevice.h>
#include <linux/skbuff.h>
#include "cap_pack.h"

static struct net_device *dev_tx;

static int cap_trans(struct sk_buff *skb, struct net_device *dev,
			struct cap_packet_type *pt)
{
	if(netif_running(dev_tx)) {
		skb->dev=dev_tx;
		skb_push(skb,sizeof(struct ethhdr)); 
		return dev_queue_xmit(skb);
	}
	printk(KERN_ERR"drop");
	return -1;
}	

struct cap_packet_type cap_trans_type;

int cap_trans_init(void)
{
	dev_tx = dev_get_by_name("eth0");
	if(dev_tx == NULL) {
		printk(KERN_ERR"TX device doesn't present");
		return -1;
	}
	dev_hold(dev_tx);
	cap_trans_type.type = htons(ETH_P_ALL);
//	cap_trans_type.dev = dev_get_by_name("eth1");
	cap_trans_type.dev = NULL;
	cap_trans_type.func = cap_trans;
	cap_trans_type.data = NULL;
	cap_trans_type.prio =  0x200;
	cap_add_pack(&cap_trans_type);
	return 0;
}

void cap_trans_exit(void)
{
	dev_put(dev_tx);
	cap_remove_pack(&cap_trans_type);
	dev_put(cap_trans_type.dev);
}

module_init(cap_trans_init);
module_exit(cap_trans_exit);
	
