#ifndef _LINUX_CAP_TYPE_H
#define _LINUX_CAP_TYPE_H
#include "cap_pub.h"
#include <linux/types.h>
#include <linux/ip.h>
#include <linux/tcp.h>
#include <linux/udp.h>
#include <linux/icmp.h>
#include <linux/igmp.h>
struct hdr_type
{
	struct timeval  stamp;
	unsigned char data[HDRLEN];
};
struct hdr_record
{
	struct timeval stamp;
	struct iphdr iph;
	union 
	{
		struct tcphdr tcph;
		struct udphdr udph;
		struct icmphdr icmph;
		struct igmphdr igmph;
		struct iphdr ipiph;
	} h;
};


struct flow_type
{
        __u32	saddr,daddr;
        __u16   sport,dport,protocol,length;
	__u32	time;
};

struct var_tcphdr 
{
#ifdef COPY_VAR_TCP_SPORT
	__u16	sport;
#endif
#ifdef COPY_VAR_TCP_DPORT
	__u16	dport;
#endif
};

struct var_udphdr 
{
#ifdef COPY_VAR_UDP_SPORT
	__u16	sport;
#endif
#ifdef COPY_VAR_UDP_DPORT
	__u16	dport;
#endif
};

struct var_type
{
#ifdef COPY_VAR_IP_VERSION
	__u8	version;
#endif
#ifdef COPY_VAR_IP_TOS
	__u8	tos;
#endif
#ifdef COPY_VAR_IP_TOTAL_LEN
	__u16	total_len;
#endif
#ifdef COPY_VAR_IP_ID
	__u16	id;
#endif
#ifdef COPY_VAR_IP_FRAGOFF
	__u16	fragoff;
#endif
#ifdef COPY_VAR_IP_TTL
	__u8	ttl;
#endif
#ifdef COPY_VAR_IP_PROTOCOL
	__u8	protocol;
#endif
#ifdef COPY_VAR_IP_CHECK
	__u16	check;
#endif
#ifdef COPY_VAR_IP_SADDR
	__u32	saddr;
#endif
#ifdef COPY_VAR_IP_DADDR
	__u32	daddr;
#endif
	union {
		struct var_tcphdr	tcphdr;
		struct var_udphdr	udphdr;
	} proto;
};

//#ifdef __KERNEL__

#define CAP_COPY_FLOW   2
#define CAP_COPY_VAR	1
#define CAP_COPY_HDR	0
#define CAP_PRIO_COPY_HDR		0x1001
#define CAP_PRIO_COPY_FLOW              0x1002
#define CAP_PRIO_COPY_VAR              	0x1003

//#endif

#endif
